/**
 * <copyright>
 *
 * Copyright (c) 2002 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors: 
 *   IBM - Initial API and implementation
 *
 * </copyright>
 *
 * plugins/org.eclipse.emf.ecore.xmi/src/org/eclipse/emf/ecore/xmi/impl/XMLResourceFactoryImpl.java, emf.ecore.xmi, org.eclipse.102, 20030326_0335VL
 * @version 1.1 3/26/03
 */
package org.eclipse.emf.ecore.xmi.impl;


import org.eclipse.emf.common.util.URI;

import org.eclipse.emf.ecore.resource.Resource;

import org.eclipse.emf.ecore.resource.impl.ResourceFactoryImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceImpl;

/**
 * This class creates XMLResourceImpl objects.
 */
public class XMLResourceFactoryImpl extends ResourceFactoryImpl 
{
  /**
   * Constructor for XMLResourceFactoryImpl.
   */
  public XMLResourceFactoryImpl() 
  {
    super();
  }

  /**
   * Creates an XMLResourceImpl and returns it.
   */
  public Resource createResource(URI uri)
  {
    return new XMLResourceImpl(uri);
  }
}
